--  Copyright (2008-2013) Cdric Coussinet (cedric.coussinet@nomoseed.net)
--
--  This program is free software: you can redistribute it and/or modify
--  it under the terms of the GNU Affero General Public License as published
--  by the Free Software Foundation, either version 3 of the License, or
--  (at your option) any later version.
--
--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
--  GNU Affero General Public License for more details.

--  You should have received a copy of the GNU Affero General Public License
--  along with this program. If not, see <http://www.gnu.org/licenses/>

with Nomo.Premise_Properties;

with Nomo.Interpreter.Types_Index.Ranges;

with Nomo.Internal_Messages.Premises;

package Nomo.Interpreter.Premises_Index.Arrays.Getting is

   use Premises_Index_Instance;

   function Get (This : in Internal_Premises;
                 I    : in Premise_Index) return not null access constant Internal_Messages.Premises.Internal_Premise;
   pragma Precondition (I > 0);
   pragma Inline (Get);

   use Types_Index.Ranges;

   function Get (This : in Internal_Premises_Types;
                 I    : in Premise_Index) return Internal_Type_Index;
   pragma Precondition (I > 0);
   pragma Inline (Get);

   use Premise_Properties;

   function Get (This     : in Internal_Premises_Properties;
                 Property : in Premise_Property) return Premise_Index;
   pragma Inline (Get);

end Nomo.Interpreter.Premises_Index.Arrays.Getting;
